/*
  File name: CCytadelaSave.h
  Copyright: (C) 2005 - 2007 Tomasz Kazmierczak

  Creation date: 16.07.2005 01:50
  Last modification date: 22.08.2007

  This file is part of Cytadela

 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 3 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *

*/

#ifndef _CCYTADELASAVE_H_
#define _CCYTADELASAVE_H_

#include <stdint.h>

enum Levels {
	LEVEL01A,
	LEVEL01B,
	LEVEL02A,
	LEVEL02B,
	LEVEL02C,
	LEVEL03A,
	LEVEL03B,
	LEVEL03C,
	LEVEL04A,
	LEVEL04B,
	LEVEL04C,
	LEVEL05A,
	LEVEL05B,
	LEVEL05C,
	LEVEL06A,
	LEVEL06B,
	LEVEL06C,
	LEVEL07A,
	LEVEL07B,
	LEVEL07C,
	LEVEL08A,
	TRAINING1,
	TRAINING2,
	TRAINING3,
	TRAINING4,
	TRAINING5,
	NO_LEVEL = 0xFF
};

enum Complex {
	CENTER,
	SEWERS,
	LABORATORY,
	STORES,
	POWER_PLANT,
	HANGAR,
	PRISON,
	Complex_FORCE_BYTE = 0xFF
};

enum Status {
	INACTIVE,
	ACTIVE,
	FINISHED,
	CENTERINACTIVE,
	Status_FORCE_BYTE = 0xFF
};

class SaveStruct {
public:
	uint16_t  wWeapons;
	uint16_t  wAmmo[6];
	uint16_t  wEnergy;
	uint16_t  wCplxCounter;
	Levels    eLevel;
	Status    eCplxStatus[7];
	uint8_t   btActualComplex;
	uint8_t   btBomb;
	bool      bDifficult;
	bool      bVisionNoise;
};

class CCytadelaSave {
public:
	SaveStruct  mSave[5];

	bool readSaveFile(char *szSysDirPath);
	bool writeSaveFile(char *szSysDirPath);
	void reset();
};

#endif
